document.addEventListener('DOMContentLoaded', function (evt) {
  var $smc = document.getElementById('system-message-container');
  if (!$smc) {
    return;
  }
  var getBtns = function () {
    var $els = $smc.querySelectorAll('#YandexIndexNow-send');
    if (!$els || $els.length < 1) {
      return false;
    }
    return $els;
  };
  var btnClickHandler = function (evt) {
    var $btn = evt.target;
    var url = $btn.dataset.url;
    if (!url) {
      return alert("IndexNow: failed to retrieve url");
    }
    $btn.classList.add('active');
    $btn.classList.remove('btn', 'btn-primary');
    $btn.setAttribute('style', 'display:none; ')
    $btn.innerHTML = '';
    var $container = $btn.parentNode;
    var baseUrl = '';
    try {
      var $jso = document.querySelector('.joomla-script-options');
      if ($jso) {
        var jopt = JSON.parse($jso.innerHTML);
        if (typeof (jopt) == 'object' && typeof (jopt['system.paths']) != 'undefined') {
          var sps = jopt['system.paths'];
          if (typeof (sps.baseFull) != 'undefined') {
            baseUrl = sps.baseFull;
          } else if (typeof (sps.base) != 'undefined') {
            baseUrl = sps.base;
          }
        }
      }
      if (baseUrl.length) {
        baseUrl = baseUrl.replace(/\/+$/, '') + '/';
      } else {
        baseUrl = '/';
      }
    } catch (e) {
    }
    var ajaxUrl = baseUrl + 'index.php?option=com_ajax' + '&group=content&plugin=indexnow&' + 'format=json&ignoreMessages=0';
    try {
      Joomla.request({
        url: ajaxUrl,
        method: 'POST',
        data: 'url=' + url,
        onSuccess: function (response, xhr) {
          $btn.classList.remove('active');
          var rv = JSON.parse(response);
          if (!rv || typeof rv != 'object') {
            return alert('IndexNow: failed to parse JSON data');
          }
          var $mc = document.createElement('div');
          var $msg = null;
          $mc.classList.add('YandexIndexNow-rv');
          if (rv.messages && typeof rv.messages == 'object') {
            var msgs = rv.messages;
            var i = 0;
            if (typeof msgs['error'] != 'undefined') {
              for (i = 0; i < msgs.error.length; i++) {
                $msg = document.createElement('div');
                $msg.classList.add('error');
                $msg.innerHTML = msgs.error[i];
                $mc.appendChild($msg);
              }
            }
            if (typeof msgs['notice'] != 'undefined') {
              for (i = 0; i < msgs.notice.length; i++) {
                $msg = document.createElement('div');
                $msg.classList.add('notice');
                $msg.innerHTML = msgs.notice[i];
                $mc.appendChild($msg);
              }
            }
            if (typeof msgs['info'] != 'undefined') {
              for (i = 0; i < msgs.info.length; i++) {
                $msg = document.createElement('div');
                $msg.classList.add('info');
                $msg.innerHTML = msgs.info[i];
                $mc.appendChild($msg);
              }
            }
            if (typeof msgs['message'] != 'undefined') {
              for (i = 0; i < msgs.message.length; i++) {
                $msg = document.createElement('div');
                $msg.classList.add('success');
                $msg.innerHTML = msgs.message[i];
                $mc.appendChild($msg);
              }
            }
          } else if (typeof rv.message != 'undefined' && rv.message) {
            $msg = document.createElement('div');
            $msg.classList.add(rv.success ? 'success' : 'error');
            $msg.innerHTML = rv.message;
            $mc.appendChild($msg);
          }
          $container.innerHTML = '';
          $container.appendChild($mc);
        },
        onError: function (xhr) {
          $container.remove();
          return alert('IndexNow: status ' + xhr.status + ' received');
        }
      });
    } catch (e) {
      $btn.classList.remove('active');
      return alert('IndexNow: failed to send request to backend: ' + e.message);
    }
    return evt.preventDefault();
  };
  var $btns = getBtns();
  if ($btns) {
    var i = 0;
    for (i = 0; i < $btns.length; i++) {
      $btns[i].onclick = btnClickHandler;
    }
  } else {
    let observer = new MutationObserver(function (mutations) {
      var $btns = getBtns();
      if (!$btns) {
        return;
      }
      var i = 0;
      for (i = 0; i < $btns.length; i++) {
        $btns[i].onclick = btnClickHandler;
      }
      observer.disconnect();
    });
    observer.observe($smc, {childList: true, attributes: false, subtree: true});
  }
});
