<?php

declare(strict_types=1);

namespace Joomla\Plugin\Content\IndexNow\Provider;

final class YandexProvider extends AbstractProvider implements ProviderInterface
{
    protected const BASE_URL = 'https://yandex.com/indexnow';

    protected function getParams(): array
    {
        return [
            'key' => $this->config->getToken(),
            'url' => $this->url,
        ];
    }

    public function getEndpoint(): string
    {
        return sprintf(
            '%s?%s',
            self::BASE_URL,
            http_build_query($this->getParams()),
        );
    }
}
