<?php

declare(strict_types=1);

namespace Joomla\Plugin\Content\IndexNow;

final class RegexMatcher
{
    /**
     * @param list<string> $patterns
     *
     * @throws \RuntimeException
     *
     * @since 4.0
     */
    public function __construct(
        private readonly array $patterns
    )
    {
    }

    public function match(string $haystack): bool    {
        foreach ($this->patterns as $pattern) {
            if (preg_match('#' . $pattern . '#', $haystack)) {
                throw new \RuntimeException($pattern);
            }
        }

        return true;
    }
}
