<?php

declare(strict_types=1);

namespace Joomla\Plugin\Content\IndexNow\UrlFetcher\Fetcher;

use Joomla\CMS\Table\TableInterface;
use Joomla\Registry\Registry;

trait MetadataTrait
{
    private function hasNoIndex(TableInterface $table): bool
    {
        if (! $table->hasField('metadata')) {
            throw new \RuntimeException('Field "metadata" does not exists');
        }

        $metadata = new Registry($table->metadata);
        $metadataString = $metadata->toString();

        $result = trim($metadataString)
            ? $metadataString
            : (new \JConfig())->robots;

        return str_contains($result, 'noindex');
    }

    private function isPublic(TableInterface $table): bool
    {
        if (! $table->hasField('access')) {
            throw new \RuntimeException('Field "access" does not exists');
        }

        return (int)$table->access === 1;
    }
}
