<?php

declare(strict_types=1);

namespace Joomla\Plugin\Content\IndexNow\UrlFetcher;

use Joomla\Component\Categories\Administrator\Table\CategoryTable;
use Joomla\Component\Content\Administrator\Table\ArticleTable;
use Joomla\Plugin\Content\IndexNow\UrlFetcher\Fetcher\ArticleFetcher;
use Joomla\Plugin\Content\IndexNow\UrlFetcher\Fetcher\CategoryFetcher;
use Joomla\Plugin\Content\IndexNow\UrlFetcher\Fetcher\Fetcher;

final class UrlFetcherFactory
{
    public static function buildFromArticle(ArticleTable $articleTable): Fetcher
    {
        return new ArticleFetcher($articleTable);
    }

    public static function buildFromCategory(CategoryTable $categoryTable): Fetcher
    {
        return new CategoryFetcher($categoryTable);
    }
}
